package jp.co.cybec.laxide.editParts;

import java.beans.PropertyChangeEvent;

import jp.co.cybec.laxide.editpolicies.LetsAjaxComponentEditPolicy;
import jp.co.cybec.laxide.editpolicies.LetsAjaxDirectEditPolicy;
import jp.co.cybec.laxide.model.base.LetsAjaxTextFieldModel;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.RequestConstants;
import org.eclipse.jface.viewers.TextCellEditor;

/**
 * テキストフィールドを描画するクラス. ファイル名：LetsAjaxTextFieldEditPart.java
 * 
 * @author nakamura 作成時刻：13:54:36
 * 
 */
public class LetsAjaxTextFieldEditPart extends EditPartWithListener {

	private LetsAjaxDirectEditManager directManager = null;

	/**
	 * 属性が変更された時に呼ばれるメソッド
	 * 
	 * @see jp.co.cybec.laxide.editParts.EditPartWithListener#propertyChange(java.beans.PropertyChangeEvent)
	 */
	public void propertyChange(PropertyChangeEvent evt) {
		// 変更の型がモデルの位置情報の変更を示すものかどうか
		if (evt.getPropertyName().equals(LetsAjaxTextFieldModel.P_CONSTRAINT)) {
			LetsAjaxTextFieldModel model = (LetsAjaxTextFieldModel) getModel();
			Label label = (Label) getFigure();

			model.setSize(Integer.toString(label.getSize().width));
			refreshVisuals(); // ビューを更新する
		} else if (evt.getPropertyName().equals(LetsAjaxTextFieldModel.P_VALUE)) {
			// モデルの変更をビューに表示する
			Label label = (Label) getFigure();
			label.setText((String) evt.getNewValue());
		} else if (evt.getPropertyName().equals(LetsAjaxTextFieldModel.P_SIZE)) {
			// モデルの変更をビューに表示する
			Label label = (Label) getFigure();
			label.setSize(Integer.parseInt((String) evt.getNewValue()), 20);
			label.setBorder(new LineBorder());
		}
	}

	/**
	 * テキストフィールドの生成
	 * 
	 * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
	 */
	protected IFigure createFigure() {
		LetsAjaxTextFieldModel model = (LetsAjaxTextFieldModel) getModel();

		Label label = new Label();
		label.setText(model.getValue());
		// 背景色を不透明に
		label.setOpaque(false);
		label.setSize(Integer.parseInt(model.getSize()), 20);
		label.setBorder(new LineBorder());
		return label;
	}

	protected void createEditPolicies() {
		// エディットポリシーを作成してインストール
		installEditPolicy(EditPolicy.COMPONENT_ROLE,
				new LetsAjaxComponentEditPolicy());
		installEditPolicy(EditPolicy.DIRECT_EDIT_ROLE,
				new LetsAjaxDirectEditPolicy());
	}

	protected void refreshVisuals() {
		// 制約の取得
		Rectangle constraint = ((LetsAjaxTextFieldModel) getModel())
				.getConstraint();

		// Rectangleオブジェクトを制約としてビューに設定する
		// setLayoutConstraintメソッドは親EditPartから呼び出す
		((GraphicalEditPart) getParent()).setLayoutConstraint(this,
				getFigure(), constraint);
	}

	public void performRequest(Request req) {
		// Requestがモデル・プロパティの直接編集を要求するものかどうか
		if (req.getType().equals(RequestConstants.REQ_DIRECT_EDIT)) {
			performDirectEdit();
			return;
		}
		super.performRequest(req);
	}

	private void performDirectEdit() {
		if (directManager == null) {
			directManager = new LetsAjaxDirectEditManager(this,
					TextCellEditor.class, new LetsAjaxCellEditorLocator(
							getFigure()));
		}
		directManager.show(); // セル・エディタの表示
	}

}
